﻿Type=StaticCode
Version=2.71
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim DBFileName As String			 : DBFileName = "dbTextwahl.db3"
	Dim DBFileDir As String				 : DBFileDir = File.DirDefaultExternal
	Dim SQL1 As SQL

End Sub

Sub fnkDBInitialisieren

	DBFileDir = CopyDBFromAssets(DBFileName)
	SQL1.Initialize(DBFileDir, DBFileName, True)

End Sub


Sub fnkSQL(strVariablename As String, strUebergabewert() As String) As String

	Dim txtSQL As String

    Select strVariablename 
    
        'SQL für Werte Holen

        Case "tblLstObjektkategorie.Alle":
            'aus tblLstObjektkategorie alle Felder
			'Word Suchen	=" & strUebergabewert 	und Ersetzen	" & strUebergabewert
			'Word Suchen	^p 						und Ersetzen	" & _^p					"
			txtSQL = "SELECT tblLstObjektkategorie.Objektkategorie_Nr, tblLstObjektkategorie.Bezeichnung, tblLstObjektkategorie.Beschreibung, tblLstObjektkategorie.Sortierer, tblLstObjektkategorie.Verwendet " & _
					"FROM tblLstObjektkategorie " & _
					"WHERE (((tblLstObjektkategorie.Verwendet)" & strUebergabewert(0) & ")) " & _
					"ORDER BY tblLstObjektkategorie.Sortierer; " 
			'tblLstObjektkategorie.Alle = basDB.fnkWertHolen ("tblLstObjektkategorie.Alle", false, strUebergabewert)
            'übergabe => strUebergabewert(0) = "='Verwendet'"		" Like '%|defRegieAusmassErfas|%'  
			'tblLstObjektkategorie.Alle	Objektkategorie_Nr|Bezeichnung|Beschreibung|Sortierer|Verwendet|
			'							0                  1           2            3         4         

        Case "tblLstStockwerk.Alle":
            'aus tblELEKTROTARIF die Ausmasstarife nach VA ausgeben für Gruppierung
			'Word Suchen	=" & strUebergabewert 	und Ersetzen	" & strUebergabewert
			'Word Suchen	^p 						und Ersetzen	" & _^p					"
			txtSQL = "SELECT tblLstStockwerk.Stockwerk_Nr, tblLstStockwerk.Bezeichnung, tblLstStockwerk.Beschreibung, tblLstStockwerk.Sortierer, tblLstStockwerk.Verwendet " & _
					"FROM tblLstStockwerk " & _
					"WHERE (((tblLstStockwerk.Verwendet)" & strUebergabewert(0) & ")) " & _
					"ORDER BY tblLstStockwerk.Sortierer; " 
			'tblLstStockwerk.Alle = basDB.fnkWertHolen ("tblLstStockwerk.Alle", false, strUebergabewert)
            'übergabe => strUebergabewert(0) = "='Verwendet'"		" Like '%|defRegieAusmassErfas|%'  
			'tblLstStockwerk.Alle	Stockwerk_Nr|Bezeichnung|Beschreibung|Sortierer|Verwendet|
			'						0            1           2            3         4         



        Case "tblLstMengentext.Alle":
            'aus tblELEKTROTARIF die Ausmasstarife nach VA ausgeben für Gruppierung
			'Word Suchen	=" & strUebergabewert 	und Ersetzen	" & strUebergabewert
			'Word Suchen	^p 						und Ersetzen	" & _^p					"
			txtSQL = "SELECT tblLstMengentext.Mengentext_Nr, tblLstMengentext.Bezeichnung, tblLstMengentext.Beschreibung, tblLstMengentext.Sortierer, tblLstMengentext.Verwendet " & _
					"FROM tblLstMengentext " & _
					"WHERE (((tblLstMengentext.Verwendet)" & strUebergabewert(0) & ")) " & _
					"ORDER BY tblLstMengentext.Sortierer; " 
			'tblLstMengentext.Alle = basDB.fnkWertHolen ("tblLstMengentext.Alle", false, strUebergabewert)
            'übergabe => strUebergabewert(0) = "='Verwendet'"		" Like '%|defRegieAusmassErfas|%'  
			'tblLstMengentext.Alle	Mengentext_Nr|Bezeichnung|Beschreibung|Sortierer|Verwendet|
			'						0             1           2            3         4         


        Case "tblLstAuswahltextThema.Alle":
            'tblLstAuswahltextThema
			'Word Suchen	=" & strUebergabewert 	und Ersetzen	" & strUebergabewert
			'Word Suchen	^p 						und Ersetzen	 " & _^p					"
			txtSQL = "Select tblLstAuswahltextThema.AuswahltextThema_Nr, tblLstAuswahltextThema.Bezeichnung, tblLstAuswahltextThema.Verwendet, tblLstAuswahltextThema.Thema " & _
					"FROM tblLstAuswahltextThema " & _
					"WHERE (((tblLstAuswahltextThema.Verwendet)" & strUebergabewert(0) & ") AND ((tblLstAuswahltextThema.Thema)" & strUebergabewert(1) & ")) " & _
					"ORDER BY tblLstAuswahltextThema.Sortierer; " 
			'tblLstAuswahltextThema.Alle = basDB.fnkWertHolen ("tblLstAuswahltextThema.Alle", false, strUebergabewert)
            'übergabe => strUebergabewert(0) = "='Verwendet'"				" Like '%|defRegieAusmassErfas|%'" 
            'übergabe => strUebergabewert(1) = "='Thema'"					für alle  "<>''"  
			'tblLstAuswahltextThema.Alle	AuswahltextThema_Nr|Bezeichnung|Verwendet|Kategorie|
			'									0                       1           2         3         


        Case "tblLstAuswahlArtikeltext.Alle":
            'tblLstAuswahlArtikeltext mit einzahlu und mehrzahl
			'Word Suchen	=" & strUebergabewert 	und Ersetzen	" & strUebergabewert
			'Word Suchen	^p 						und Ersetzen	" & _^p					"
			txtSQL = "SELECT tblLstAuswahlArtikeltext.AuswahlArtikeltext_Nr, tblLstAuswahlArtikeltext.Bezeichnung, tblLstAuswahlArtikeltext.Einzahl, tblLstAuswahlArtikeltext.Mehrzahl, tblLstAuswahlArtikeltext.Beschreibung, tblLstAuswahlArtikeltext.Thema " & _
					"FROM tblLstAuswahlArtikeltext " & _
					"WHERE (((tblLstAuswahlArtikeltext.AuswahlArtikeltext_Nr)" & strUebergabewert(0) & ") AND ((tblLstAuswahlArtikeltext.Bezeichnung)" & strUebergabewert(1) & ") AND ((tblLstAuswahlArtikeltext.Thema)" & strUebergabewert(2) & ")) " & _
					"ORDER BY tblLstAuswahlArtikeltext.Sortierer; " 
			'tblLstAuswahlArtikeltext.Alle = basDB.fnkWertHolen ("tblLstAuswahlArtikeltext.Alle", false, strUebergabewert)
            'übergabe => strUebergabewert(0) = "=AuswahlArtikeltext_Nr"		für alle "<>0" 
            'übergabe => strUebergabewert(1) = "='Bezeichnung'"				für alle  "<>''" 
            'übergabe => strUebergabewert(2) = "='Thema'"					" Like '%|Kategorie|%'  
			'tblLstAuswahlArtikeltext.Alle	AuswahlArtikeltext_Nr|Bezeichnung|Einzahl|Mehrzahl|Beschreibung|Kategorie|
			'								0                     1           2       3        4            5                  


        Case "tblLstAuswahlLeistungtext.Alle":
            'aus tblELEKTROTARIF die Ausmasstarife nach VA ausgeben für Gruppierung
			'Word Suchen	=" & strUebergabewert 	und Ersetzen	" & strUebergabewert
			'Word Suchen	^p 						und Ersetzen	" & _^p					"
			txtSQL = "SELECT tblLstAuswahlLeistungtext.AuswahlLeistungtext_Nr, tblLstAuswahlLeistungtext.Bezeichnung, tblLstAuswahlLeistungtext.Beschreibung, tblLstAuswahlLeistungtext.Thema " & _
					"FROM tblLstAuswahlLeistungtext " & _
					"WHERE (((tblLstAuswahlLeistungtext.Thema)" & strUebergabewert(0) & ")) " & _
					"ORDER BY tblLstAuswahlLeistungtext.Sortierer; " 
			'tblLstAuswahlLeistungtext.Alle = basDB.fnkWertHolen ("tblLstAuswahlLeistungtext.Alle", false, strUebergabewert)
            'übergabe => strUebergabewert(0) = "='Thema'"				" Like '%|Kategorie|%'  
			'tblLstAuswahlLeistungtext.Alle	AuswahlLeistungtext_Nr|Bezeichnung|Beschreibung|Kategorie|
			'								0                      1           2            3         

		Case Else

			Msgbox ("Programm Ausnahmefehler bitte Administrator benachrichtigen! Die Funktion 'fnkSQL (" & strVariablename & ")' im Modul basDB findet keinen entsprechenden Eintrag.", "Programm Ausnahmefehler")
    		txtSQL = ""
    End Select

	Log("")
	Log(strVariablename)
	Log(txtSQL)

	Return txtSQL

End Sub



Sub fnkWertHolen(strVariablename As String, bolEinzelergebniss As Boolean, strUebergabewert() As String) As Cursor
'strVariablename        =>  Name des SQL Spezifikation
'bolEinzelergebniss     =>  wenn Ja dann wird nur die Erste spalte der ersten Zeile zurück gegeben  
'strWennNull            =>  Was soll zurückgegeben werden wenn keine Daten kommen

	Dim Cursor1 As Cursor
	Dim txtSQL As String

	txtSQL = fnkSQL(strVariablename, strUebergabewert)

	Cursor1 = SQL1.ExecQuery(txtSQL)
	
	Return Cursor1


End Sub


Sub CopyDBFromAssets (FileName As String) As String
	Dim TargetDir As String
	If File.ExternalWritable Then TargetDir = File.DirDefaultExternal Else TargetDir = File.DirInternal
	File.Copy(File.DirAssets, FileName, TargetDir, FileName)
	Return TargetDir
End Sub
